import { EntityProvider, EntityProviderConnection } from '@backstage/plugin-catalog-backend';
import { Config } from '@backstage/config';

interface SourcegraphWebhookPayload {
    monitorDescription: string;
    monitorUrl: string;
    query: string;
    results: {
        repository: string;
        commit: string;
        diff: string;
        matchedDiffRanges: number[][];
    }[];
}

declare class SourcegraphEntityProvider implements EntityProvider {
    private readonly config;
    private connection?;
    private graphQLClient?;
    static create(config: Config): SourcegraphEntityProvider;
    private constructor();
    getProviderName(): string;
    connect(connection: EntityProviderConnection): Promise<void>;
    full(): Promise<void>;
    delta(payload: SourcegraphWebhookPayload): Promise<void>;
}

export { SourcegraphEntityProvider };
